package org.ff4j.web.api.security;

/*
 * #%L
 * ff4j-web
 * %%
 * Copyright (C) 2013 - 2015 Ff4J
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.ff4j.security.AbstractAuthorizationManager;
import org.ff4j.web.api.resources.FF4jResource;


/**
 * Implementation of Manager to base permissions on incoming user.
 *
 * @author <a href="mailto:cedrick.lunven@gmail.com">Cedrick LUNVEN</a>
 */
public class FF4JSecurityContextAuthenticationManager extends AbstractAuthorizationManager{

    /** {@inheritDoc} */
    @Override
    public Set<String> getCurrentUserPermissions() {
        FF4jSecurityContext secCtx = FF4jResource.securityContextHolder.get();
        if (secCtx != null) {
            return secCtx.getUserRoles();
        }
        return new HashSet<String>();
    }

    /** {@inheritDoc} */
    @Override
    public Set<String> listAllPermissions() {
        Set < String > vars = new HashSet<String>();
        if (FF4jSecurityContextFilter.securityConfig != null) {
            Map < String, Set<String > > perms = FF4jSecurityContextFilter.securityConfig.getPermissions();
            for (String var : perms.keySet()) {
                perms.get(var).addAll(perms.get(var));
            }
        }
        return vars;
    }
}
